<template>
  <v-container>
    <v-layout text-center wrap>
      <v-flex xs12>
        <v-alert
            v-if="hasError"
            v-model="hasError"
            type="error"
            dark
            dismissible
        >
          Возникла ошибка при попытке загрузить данные. Пожалуйста обновите страницу и попытайтесь еще раз.
        </v-alert>

        <v-data-table
            v-else
            :headers="headers"
            :items="users"
            class="elevation-1"
            :loading="loading"
            loading-text="Данные загружаются... Пожалуйста подождите"
            :footer-props="{
              itemsPerPageText: 'Записей на странице',
              itemsPerPageAllText: 'Все'
            }"
        >
          <template v-slot:body.prepend>
            <tr>
              <td><v-text-field v-model="userId"></v-text-field></td>
              <td><v-text-field v-model="id"></v-text-field></td>
              <td><v-text-field v-model="title"></v-text-field></td>
              <td class="text-left">
                <v-btn class="mx-2" outlined color="indigo" @click="filterUsers"><v-icon>mdi-magnify</v-icon></v-btn>
                <v-btn class="mx-2" outlined color="red" @click="clearFilter"><v-icon>mdi-close</v-icon></v-btn>
              </td>
            </tr>
          </template>
          <template v-slot:item.body="{ item }">
            <span>{{ item.body|truncate }}</span>
          </template>
          <template v-slot:footer.page-text="{ pageStart, pageStop, itemsLength }">
            Показаны записи: {{ pageStart }} - {{ pageStop }} из {{ itemsLength }}
          </template>
        </v-data-table>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
  export default {
    name: 'UsersTable',

    created() {
      this.getUsers()
    },

    data: () => ({
      headers: [
        { text: 'ID пользователя', align: 'left', value: 'userId' },
        { text: 'ID записи',value: 'id' },
        { text: 'Заголовок', value: 'title' },
        { text: 'Текст', value: 'body' }
      ],
      users: [],
      allUsers: [],
      hasError: false,
      loading: false,
      userId: '',
      id: '',
      title: ''
    }),

    methods: {
      getUsers() {
        this.loading = true
        this.$axios.get('https://jsonplaceholder.typicode.com/posts').then( response => {
          this.users = response.data
          this.allUsers = response.data
        }).catch((err) => {
          this.hasError = true
        }).finally( () => {
          this.loading = false
        })
      },

      filterUsers() {
        this.users = this.allUsers.filter( item => {
          return this.filterUserId(item) && this.filterId(item) && this.filterTitle(item)
        })
      },

      clearFilter() {
        this.users = [...this.allUsers]
        this.userId = ''
        this.id = ''
        this.title = ''
      },

      filterUserId(item) {
        if(!this.userId){
          return true
        } else {
          return item.userId == this.userId
        }
      },

      filterId(item) {
        if(!this.id){
          return true
        } else {
          return item.id == this.id
        }
      },

      filterTitle(item) {
        if(!this.title){
          return true
        } else {
          return item.title.indexOf(this.title) >= 0
        }
      }
    }
  };
</script>
